;*************************************************************************
; FILENAME	:	ex1_main.asm
; ROUTINES	:	ex1_main
;			
;*************************************************************************
;************************************************************************
;PURPOSE	:	Simple program to fill a memory range in x
;			and y memory and then compute the accumulated
;			product						 
;************************************************************************
	TITLE	'MAC DEMO'
;****** Definition of Constants *********
SINGLE_LEN	equ  $40			; length of the test data stream

;*********** DATA:   **********************
	SECTION	x_test_data			; define a section name for allocation
	GLOBAL	x_dat				; define label for use in program section
	ORG	x:				; define memory space for user data
x_dat	DS SINGLE_LEN				; reserve memory for x input data
	ENDSEC
	SECTION	y_test_data			; define a section name for allocation
	GLOBAL	y_dat				; define label for use in program section
	ORG	y:				; define memory space for user data
y_dat 	DS SINGLE_LEN				; reserve memory for y input data
	ENDSEC

;******	PROGRAM:   **********************	
	SECTION ex1_code			; declare a program section,..
	ORG	p:				; to be located in p RAM
						; see ex1.ctl for allocation
ex1_start	; ** now the initialisation is done without 
		; ** looking at the pipeline-> assembler warnings
		; ** please see textfile for explanation
	clr 	a				; clear accumulator a	
	clr	b				; clear accumulator b	
	move	#x_dat,r0			; init start address pos numbers
	move	#y_dat,r1			; init start address neg numbers
	do 	#SINGLE_LEN,init_2		; start the loop here, do $40 times
	inc 	a				; increment a 
	move 	a0,x:(r0)+			; write a0 to positive number field 
	dec	b				; decrement b
	move  	b0,y:(r1)+			; write b0 to negative number field 
		; ** now the initialisation is done avoiding 
		; ** pipeline conflicts
init_2	move 	#$01,a0				; init accumulator a	
	move	#$ff,b0				; init accumulator b	
	move	#x_dat,r0			; init start address pos numbers
	move	#y_dat,r1			; init start address neg numbers
	do 	#SINGLE_LEN,end_init		; start the loop here, do $40 times
	move 	a0,x:(r0)+			; write a0 to positive number field 
	inc 	a				; increment a 
	move  	b0,y:(r1)+			; write b0 to negative number field 
	dec	b				; decrement b
end_init
	move	#x_dat,r0			; init start address pos numbers
	move	#y_dat,r4			; init start address neg numbers
	clr	a				; wait for r0/r4 to be updated...
	move	x:(r0)+,x0			; now set addresses for..
	move	y:(r4)+,y0			; read x and y inputs
	rep	#SINGLE_LEN			; and start loop
	mac	x0,y0,a	x:(r0)+,x0  y:(r4)+,y0	; of macs
end_mac	nop					; label for breakpoint
	bra	end_mac				; that's it: is the sum in accu a 
	ENDSEC					; now correct?
