;*************************************************************************
; FILENAME	:	ex3_main.asm
; ROUTINES	:	ex3_main
;			SIG24DIV
;*************************************************************************
;************************************************************************
;SUBROUTINE	:	ex3_main.asm
;PURPOSE	
;		This is the entry point for the worked example in exercise
;		2. It makes two calls to the subroutine
;		SIG24DIV. The results are stored in a buffer in X memory
;************************************************************************
	TITLE	'DIV DEMO'
	section	ex3_main
	xref	SIG24DIV
DIVIDEND_LO1	EQU	$563445
DIVIDEND_HI1	EQU	$F65443
DIVIDEND_LO2	EQU	$749837
DIVIDEND_HI2	EQU	$FF8734
DIVISOR1	EQU	$123456
DIVISOR2	EQU	$F12345
	org	p:
	move	#DIVIDEND_HI1,a	
	move	#DIVIDEND_LO1,a0
	move	#DIVISOR1,x0
	bsr	SIG24DIV	;positive dividend, positive divisor
	move	#DIVIDEND_HI1,a
	move	#DIVIDEND_LO1,a0 
	move	#DIVISOR2,x0
	bsr	SIG24DIV	;positive dividend, negative divisor
	move	#DIVIDEND_HI2,a
	move	#DIVIDEND_LO2,a0
	move	#DIVISOR1,x0
	bsr	SIG24DIV	;negative dividend, positive divisor
	move	#DIVIDEND_HI2,a
	move	#DIVIDEND_LO2,a0
	move	#DIVISOR2,x0
	bsr	SIG24DIV	;negative dividend, negative divisor
	jmp	*
	endsec
;*************************************************************************
;SUBROUTINE	:	SIG24DIV.ASM
;PURPOSE	 	
;		This is a division subroutine which implements a 4 quadrant
;		divide (i.e. a signed divisor and a signed dividend) and 
;		generates a 24-bit signed quotient and a 48-bit signed
;		remainder, Given a 48 bit dividend and a 24 bit divisor.
;INPUTS		
;		Dividend must be stored in the low 48 bits of accumulator a
;		and must be a positive number
;
;		Divisor must be stored in x0, and must be larger than the
;		dividend to produce a fractional result.
;
;OUTPUTS
;		The quotient will be in x1
;	
;		The remainder will be in b1
;**************************************************************************
	section sig24div
	xdef SIG24DIV
	org p:
SIG24DIV
	abs	a	a,b	;make dividend positive, copy a1 to b1
	eor	x0,b	b,y0	;save rem. sign in x1, quo sign in N
	and	#$FE,ccr 	;clear carry bit C (quotient sign bit)
	rep	#$18		;form a 24-bit quotient
	div	x0,a		;form quotient in a0, remainder in a1
	tfr	a,b		;save remainder and quotient in b
	jpl	saveq		;of quotient is positive, go to saveq
	neg	b		;complement quotient if N bit is set
saveq	tfr	x0,b	b0,x1	;save quo. in x1, get signed divisor
	abs	b		;get absolute value of signed divisor
	add	a,b		;restore remainder in b1
	jclr	#23,y0,done	;go to done if remainder is positive
	move	#$0,b0		;prevent unwanted carry
	neg	b		;complement remainder
done	rts			
	endsec
