;**********************************************************************
; FILENAME	: ex4_main.asm
;
; ROUTINES	: This file containes the main function (entry point) 
;		for exercise 4. 
;
; PURPOSE	: This section of code implements a general FIR filter. 
;		All relevant values are set up using user defined 
;		variables (e.g.NUM_OF_TAPS) which can be easily edited 
;		to change the operation of the program.
;		This section references the assembly code function 
;		'fir_filter' which exists in section 'fir_filter' within 
;		file 'ex4_fir.asm'
;
;**********************************************************************
	TITLE	'EX4 MAIN'
	section exercise_4_main
	xref	fir_filter	;subroutine fir_filter is referenced 
				;from an external file.
NUM_OF_TAPS	EQU	10	;number of taps in the filter
NUM_OF_INPUTS	EQU	30	;number new inputs which are to 
				;be processed on each call to the 
				;FIR filter
INPUT_FILE_ADDRESS	EQU	$FFFFEE
OUTPUT_FILE_ADDRESS	EQU	$FFFFEF
	org	x:
input_buffer	ds	NUM_OF_INPUTS
				;reserve NUM_OF_INPUTS words of X memory
				;and label as input_buffer
	org	y:
	BUFFER	M,NUM_OF_TAPS
				;Indicate that the following constants
				;have to be stored in a space suitable
				;for a modulo NUM_OF_TAPS buffer
fir_taps	dc	$001EF4,$FFFC05,$000F7B,$002F01,$FF9329
		dc	$FF9329,$002F01,$000F7B,$FFFC05,$001EF4
	ENDBUF
				;Note: The taps values here are 
				;random they do not represent any 
				;real filter
output_buffer	ds	NUM_OF_INPUTS
				;reserve NUM_OF_INPUTS words of Y memory
				;and label as output_buffer
;**********************************************************************
; Main Program
;**********************************************************************
	org	p:
	dor	forever,end_of_loop
	
;read in the first block of data from external source
	move	#input_buffer,r0
	rep	#NUM_OF_INPUTS
	movep	y:<<INPUT_FILE_ADDRESS,x:(r0)+
load_input
;set up pointers for the call to FIR subroutine
	move	#input_buffer,r0
	move	#fir_taps,r4
	move	#output_buffer,r2
	move	#NUM_OF_TAPS,r3
	move	#NUM_OF_INPUTS,r1
	
;call FIR subroutine 
	bsr	fir_filter
;move the output buffer to the output file
	move	#output_buffer,r0
	rep	#NUM_OF_INPUTS
	movep	y:(r0)+,y:<<OUTPUT_FILE_ADDRESS	
end_of_loop
	endsec
