;*************************************************************************
; FILENAME	:	ex5_root.asm
; ROUTINES	:	root_24
;*************************************************************************
;************************************************************************
;SUBROUTINE	:	root_24
;PURPOSE	
;		Function file for root calculation
;************************************************************************
;Input:		48 bit fractional number in register x1:x0
;Output: 	squareroot in accumulator b
;***********************************************************
	opt	CC
;****** Definition of Constants *********
ITS	equ	24				; number of iterations
;******	PROGRAM:   **********************	
	SECTION ex5_code			; declare a program section,..
	xdef	root_24
	ORG	p:				; to be located in p RAM
						; see ex5.ctl for allocation
root_24
	btst	#23,x1				; check if neg input
	clr	b	ifcs			; if neg, set res to 0 (no CCR modify)..
	bcs	rootloop			; ..and go to the end
	clr	a	#<$40,y0		; init estimation with msb
	move		y0,y1			; save actual estimation for
						; for update of a
	do	#ITS-1,rootloop			; iteration loop starts here
	mpy	-y0,y0,b			; calc ref value (-est*est)
	add	x,b				; check if greater than input
	tge	y0,a				; if yes, update result..
	tfr	y1,b				; and update estimation for
	asr	b				; next iteration with (n-1)st bit
	add	a,b	b,y1			; and save sum for next..	
	move	b,y0				; ..estimation
rootloop
	rnd	b				; round value before being stored
						; by the calling main program
	rts					; end of loop and end of function 
	ENDSEC
