;****************************************************************
; FILENAME : ex7.asm
;
; ROUTINES : program for demonstration of certain  
;	     instructions on the DSP56300 
;****************************************************************
	TITLE	'EX7'

;****** Definition of Constants **********
loop_c	equ	4
b_init	equ	3
a_init	equ	2
x_init	equ	1
;******	MAIN PROGRAM:   *******************	
	SECTION ex7_code			; declare a program section,..
	ORG	p:				; to be located in p RAM
ex7_start
	clr	a
	clr	b
	move	#>x_init,x0			; init x0 
	move	#>a_init,y0			; init y0 
	move	#>b_init,y1			; init y1	
;*************************************************
; Example 1:
; first the BRKcc instruction is shown:
ins1	move	y0,a				; init accumulator	
	do	#loop_c,loop1			; init the loop
	sub	#1,a				; decrement accumulator
	nop					; wait for condition
	brkeq					; break on accu 0
	nop					; the last 3 words of a loop
	nop					; should not contain a brkcc
	nop					; (pipeline conflict)
loop1	nop					; note, that this 'nop' is not
						; part of the loop !
;*************************************************
; Example 2:
; now the debugcc instruction is used:
ins2	move	y0,a				; init a
	neg	a				; init a = -2
	add	#1,a				; a = -1
	debugle					; stop execution and wait
	nop					; for OnCE command (enter run
	nop					; .. or step in the debugger)
;*************************************************
; Example 3:
; now the ifcc instruction is used, representing ifcc and ifcc.u
;
ins3	move	y0,a				; init a for operation
	add	x0,a				; add x0 to a (cond tested for ifcc)
	sub	x0,a	ifne			; now subtract x0, IF x0+a was not 
						; ..zero (executed here)
	move	#>-a_init,a			; re-init a
	move	x0,b
	addl	a,b				; add 2*x0 to a (cond tested for ifcc)				
	sub	x0,a	ifne			; now subtract x0, IF x0+a was 
						; ..zero (not executed here)
	nop			
;*************************************************
; Example 4:
; now the cmp instruction:
ins4	clr	a
	clr	b
	move	y0,a				; init a for operation
	move	y1,b				; init b for operation
						; a=2, b=3
	cmp 	a,b				; now: compare 2(a) and 3(b)
	bscc	carryclear			; a < b -> c clear
	bscs	carryset			; 
second	sub	#1,b				; b=2
	cmp 	a,b				; now: compare 2(a) and 2(b)
	bscc	carryclear			; a = b -> c clear
	bscs	carryset			; 
third	sub	#1,b				; b=1
	cmp 	a,b				; now: compare 2(a) and 1(b)
	bscc	carryclear			; a > b -> c set
	bscs	carryset			; 
	bra	end_ins4
carryclear
	rts
carryset
	rts
end_ins4
;*************************************************
; Example 5:
; now the enddo instruction is used
ins5	nop
	move	y0,a				; init accumulator	
	do	#loop_c,go_on			; init the loop
	sub	#1,a				; decrement accumulator
	nop					; wait for condition
	bne	go_on				;
	enddo					; break on accu 0
	nop
	nop
go_on	bra	go_on				; execution's termination
	ENDSEC					; end of code
;*************************************************
